#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void	tencode(void *datain,int len,void **dataout)
{
	int		nlen = len + (len + 6) / 7;
	int		t,i,r;
	unsigned char	*in,*out;

	if((*dataout = malloc(nlen)) == NULL)
	{
		return;
	}

	in = (char*)datain;
	out = *(char**)dataout;

	for(t = 0;t < len / 7;t++)
	{
		out[t * 8 + 7] = 128;
		for(i = 0;i < 7;i++)
		{
			out[t * 8 + 7] |= (in[t * 7 + i] & 128) >> (7 - i);
			out[t * 8 + i] = (in[t * 7 + i] & 127) + 1;
		}
	}
	r = len % 7;
	out[t * 8 + r] = 128;
	for(i = 0;i < r;i++)
	{
		out[t * 8 + r] |= (in[t * 7 + i] & 128) >> (7 - i);
		out[t * 8 + i] = (in[t * 7 + i] & 127) + 1;
	}
}

int	tdecode(void *datain,void **dataout)
{
	int		len = strlen((char*)datain);
	int		nlen = len - (len + 7) / 8;
	int		t,i,r;
	unsigned char	c,*in,*out;

	if((*dataout = malloc(nlen)) == NULL)
	{
		return 0;
	}

	in = (char*)datain;
	out = *(char**)dataout;

	for(t = 0;t < nlen / 7;t++)
	{
		for(i = 0;i < 7;i++)
		{
			// (in[t * 7 + i] & 128) >> (7 - i);
			c = (in[t * 8 + 7] << (7 - i)) & 128;
			// (in[t * 7 + i] & 127) + 1;
			c |= in[t * 8 + i] - 1;
			out[t * 7 + i] = c;
		}
	}
	r = nlen % 7;
	for(i = 0;i < r;i++)
	{
		c = (in[t * 8 + r] << (7 - i)) & 128;
		c |= in[t * 8 + i] - 1;
		out[t * 7 + i] = c;
	}

	return nlen;
}

void	main(void)
{
	unsigned char	array[20] = {0,1,2,126,127,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0};
	unsigned char	*en,*de;
	int		t,l;

	printf("Array\t");
	for(t = 0;t < 20;t++)
		printf("%5i",array[t]);

	tencode((void*)array,20,(void**)&en);

	printf("\nEncoded\t");
	for(t = 0;t < strlen(en);t++)
		printf("%5i",en[t]);

	l = tdecode((void*)en,(void**)&de);

	printf("\nDecoded\t");
	for(t = 0;t < l;t++)
		printf("%5i",de[t]);

	printf("\n");

}


